Subject: bug#49893: closed (Re: bug#49893: [PATCH] Reset mtime of a reverted buffer)

From: [email-masked] (GNU bug Tracking System)
Date: Thu, 05 Aug 2021 17:52:02 +0000

Your bug report

#49893: [PATCH] Reset mtime of a reverted buffer

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
49893: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=49893
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#49893: [PATCH] Reset mtime of a reverted buffer
From: Eli Zaretskii <[email-masked]>
To: Konstantin Kharlamov <[email-masked]>
Cc: [email-masked]
Date: Thu, 05 Aug 2021 20:51:31 +0300
List-Id: <debbugs-submit.debbugs.gnu.org>

> From: Konstantin Kharlamov <[email-masked]>
> Cc: [email-masked]
> Date: Thu, 05 Aug 2021 19:54:03 +0300
> 
> On Thu, 2021-08-05 at 19:36 +0300, Eli Zaretskii wrote:
> > > From: Konstantin Kharlamov <[email-masked]>
> > > Date: Thu, 05 Aug 2021 18:28:28 +0300
> > > 
> > > Patch is attached. This resolves the problem reported at
> > > https://github.com/emacs-evil/evil/issues/1504
> > 
> > Could you please describe the problem you are trying to solve,
> > preferably without involving Evil?
> 
> Sure. The auto-revert-mode by default works with ‘revert-buffer-insert-file-contents--default-function’ function. This function is known to break markers in buffers, which is why recently Emacs has added a replacement function revert-buffer-insert-file-contents-delicately (the one I modify in the patch).
> 
> However, actually trying to use this new function revealed a regression in behavior of another function: the `find-file`. Basically, if you have a file `/tmp/foo` opened in Emacs (IOW Emacs has a buffer associated with this file), and then file `/tmp/foo` gets "auto-reverted", then if you execute (find-file "/tmp/foo"), the new function causes Emacs ask a user "File foo was modified, do you want to revert it? (yes/no)". It now gives that prompt always, until you make a change to the buffer.
> 
> That's a regression compared to the default behavior with `revert-buffer-insert-file-contents--default-function`. And the reason turned out to be that the function `revert-buffer-insert-file-contents--default-function` after having succesfully reverted a file, sets the buffer mtime to the mtime of the file. However the function revert-buffer-insert-file-contents-delicately didn't set mtime before that patch. I assume it is an omission from implementation, because technically that's incorrect: if the revert-buffer-insert-file-contents-delicately has successfully reverted a buffer, then we know that it has same content as the associated file, and hence it should have the same mtime.

Thanks.  I installed the change on the master branch.

Subject: [PATCH] Reset mtime of a reverted buffer
From: Konstantin Kharlamov <[email-masked]>
To: [email-masked]
Date: Thu, 05 Aug 2021 18:28:28 +0300
List-Id: <debbugs-submit.debbugs.gnu.org>

Patch is attached. This resolves the problem reported at https://github.com/emacs-evil/evil/issues/1504

From 99266c4ba2d0391572a9b06149a0f50031bb44a2 Mon Sep 17 00:00:00 2001
From: Konstantin Kharlamov <[email-masked]>
Date: Thu, 5 Aug 2021 18:25:56 +0300
Subject: [PATCH] Reset mtime of a reverted buffer

* lisp/files.el (revert-buffer-insert-file-contents-delicately):
Once buffer is reverted, reset its mtime to that of the file.
---
 lisp/files.el | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

diff --git a/lisp/files.el b/lisp/files.el
index 2b13d04bcbe..c2607956915 100644
--- a/lisp/files.el
+++ b/lisp/files.el
@@ -6533,7 +6533,8 @@ revert-buffer-insert-file-contents-delicately
       ;; See comments in revert-buffer-with-fine-grain for an explanation.
       (defun revert-buffer-with-fine-grain-success-p ()
         success))
-    (set-buffer-modified-p nil))))
+    (set-buffer-modified-p nil)
+    (set-visited-file-modtime))))
 
 (defun revert-buffer-with-fine-grain (&optional ignore-auto noconfirm)
   "Revert buffer preserving markers, overlays, etc.
-- 
2.32.0